<template>
    <div class="wrapper">
        <nav-title :title="title" :icon="icon"></nav-title>

        <div class="md-layout mt-3 md-alignment-top-center">
            <loading :active.sync="loading" is-full-page></loading>
            <div class="md-layout-item md-xlarge-size-60 md-large-size-60 md-medium-size-90 md-small-size-95">
                <div v-if="resources.length > 0" class="md-layout md-gutter mt-2">
                    <div
                        class="md-layout-item md-xlarge-size-33 md-large-size-33 md-medium-size-33 md-small-size-100 md-no-gutter"
                        v-for="resource in resources"
                        :key="resource.id"
                    >
                        <card-recurso :resource="resource" sizeTruncate="180">
                            <template slot="image">
                                <md-card-content>
                                    <md-card-media>
                                        <img :src="resource.randomImage" :alt="resource.label" class="resource-img" />
                                        <!-- width="352" height="198" -->
                                    </md-card-media>
                                </md-card-content>
                            </template>
                            <template slot="button">
                                <ver-recurso class="no-margin" :resource="resource"></ver-recurso>
                            </template>
                            <template slot="icon">
                                <md-badge class="md-square color-badge " md-position="bottom" :md-content="resource.rating">
                                    <md-button class="md-icon-button md-dense  no-margin">
                                        <md-icon class="text-primary">star_border_purple500</md-icon>
                                    </md-button>
                                </md-badge>
                            </template>
                        </card-recurso>
                    </div>
                </div>
                <div v-else class="md-layout md-gutter mt-2">
                    <span class="md-subheading">Sin resultados </span>
                </div>
                <!-- <div v-if="resources.length > 0" class="md-layout mt-3 ">
                    <div class="md-layout-item text-align-center">
                        <pagination class="mt-2" v-model="page" :page-count="3">
                        </pagination>
                    </div>
                </div> -->
            </div>
        </div>
        <div v-if="pageCount" class="md-layout mt-3 md-alignment-top-center">
            <pagination class="mt-2" v-model="page" :page-count="pageCount"></pagination>
        </div>
    </div>
</template>

<script>
import axios from 'axios';
import CardRecurso from '../components/Recursos/CardRecurso.vue';
import VerRecurso from '../components/Recursos/VerRecurso.vue';
import Pagination from '../../components/Pagination.vue';
import NavTitle from '../../layout/NavTitle.vue';
export default {
    components: {
        CardRecurso,
        VerRecurso,
        Pagination,
        NavTitle
    },
    name: 'Recursos',
    data() {
        return {
            icon: 'list',
            title: 'Recursos',
            resourcesEndPoint: '/api/allResource',
            resourcesBySearchEndPoint: '/api/search',
            resourcesByCategoriesEndPoint: '/api/getResourceByCategories?categories',
            resourcesTopEndPoint: '/api/topTwelve',
            resourceByAuthorEndPoint: '/api/resourceByAuthor/',
            resourceByCollectionEndPoin: '/api/getResourceByCollection/',
            resources: [],
            itemsPerRow: 3,
            loading: false,
            page: 1,
            numResults: 12,
            pageCount: 0
        };
    },
    computed: {
        user() {
            return this.$auth.watch.data;
        },
        rowCount() {
            return Math.ceil(this.resources.length / this.itemsPerRow);
        }
    },
    methods: {
        getResources() {
            this.loading = true;
            const uri = `${this.resourcesEndPoint}?page=${this.page}&num_results=${this.numResults}`;
            axios
                .get(uri)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.resources = Object.assign([], res.data.data.data);
                        this.FilterResourcesWithCategories();
                        this.pageCount = res.data.data.total_pages;
                    } else {
                        this.resources = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getResources' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        getResourcesBySearch(queryParams) {
            let queryString = '?';
            queryString += queryParams.title ? `title=${queryParams.title}` : 'title=';
            queryString += queryParams.category_id ? `&category_id=${queryParams.category_id}` : '&category_id=';
            queryString += queryParams.author_id ? `&author_id=${queryParams.author_id}` : '&author_id=';
            const url = `${this.resourcesBySearchEndPoint}${queryString}&page=${this.page}&num_results=${this.numResults}`;
            this.loading = true;

            axios
                .get(url)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.resources = Object.assign([], res.data.data.data);
                        this.FilterResourcesWithCategories();
                        this.pageCount = res.data.data.total_pages;
                    } else {
                        this.resources = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getResourcesBySearch' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        getResourcesByCategories(queryParams) {
            this.loading = true;
            let uri = `${this.resourcesByCategoriesEndPoint}=%5B${queryParams}%5D&page=${this.page}&num_results=${this.numResults}`;
            axios
                .get(uri)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.resources = Object.assign([], res.data.data.data);
                        this.FilterResourcesWithCategories();
                        this.pageCount = res.data.data.total_pages;
                    } else {
                        this.resources = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getResourcesByCategories' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        getResourceByAuthor(queryParams) {
            this.loading = true;
            let uri = `${this.resourceByAuthorEndPoint}${queryParams}?page=${this.page}&num_results=${this.numResults}`;
            axios
                .get(uri)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.resources = Object.assign([], res.data.data.data);
                        this.FilterResourcesWithCategories();
                        this.pageCount = res.data.data.total_pages;
                    } else {
                        this.resources = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getResourceByAuthor' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        getResourceByCollection(queryParams) {
            this.loading = true;
            let uri = `${this.resourceByCollectionEndPoin}${queryParams}?page=${this.page}&num_results=${this.numResults}`;
            axios
                .get(uri)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.resources = Object.assign([], res.data.data.resources);
                        this.FilterResourcesWithCategories();
                        this.pageCount = res.data.data.total_pages;
                    } else {
                        this.resources = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getResourceByCollection' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        getResourcesTop() {
            this.loading = true;
            axios
                .get(this.resourcesTopEndPoint)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.resources = Object.assign([], res.data.data);
                    } else {
                        this.resources = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getResourcesTop' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        FilterResourcesWithCategories() {
            this.resources = this.resources.filter((r) => r.categories_info && r.categories_info.length > 0);
        },
        itemCountInRow(index) {
            return this.resources.slice((index - 1) * this.itemsPerRow, index * this.itemsPerRow);
        },
        validateQueryParams() {
            const query = this.$route.query;

            try {
                if (query == undefined || Object.keys(query).length === 0) {
                    this.getResources();
                } else {
                    if (query.title || query.category_id || query.author_id) {
                        this.getResourcesBySearch(query);
                    } else if (query.categories) {
                        this.getResourcesByCategories(query.categories);
                    } else if (query.Author) {
                        this.getResourceByAuthor(query.Author);
                    } else if (query.Collection) {
                        this.getResourceByCollection(query.Collection);
                    } else if (query.Top) {
                        this.getResourcesTop();
                    }
                }
            } catch (error) {
                this.$root.ErrorMgs('Error al obtener los recursos');
            }
        }
    },
    watch: {
        '$route.query'(val) {
            this.validateQueryParams();
        },
        page(val) {
            this.getResources();
        }
    },
    mounted() {
        this.validateQueryParams();
    }
};
</script>

<style lang="scss" scoped>
.md-button {
    min-width: 0px !important;
    margin: 0px !important;
}
</style>
